package net.bajobongo.zerro.geometry;

public class Geometry {
	public static Position move(Position start, double length, double direction) {
		Position result = new Position(
			start.x + (length * Math.sin(direction)),
			start.y + (length * Math.cos(direction))
		);
		return(result);
	}
	public static double direction(double x1, double y1, double x2, double y2) {
		if (y2 == y1) {
			if (x2 > x1) {
				return(Math.PI/2);
			} else {
				return(-Math.PI/2);
			}
		}
		double direction = Math.atan(Math.abs(x2 - x1) / Math.abs(y2 - y1));
		if ((y2 >= y1) && (x2 >= x1)) {
			// NOP
		}
		if ((y2 < y1) && (x2 >= x1)) {
			direction = Math.PI - direction;
		}
		if ((y2 < y1) && (x2 < x1)) {
			direction += Math.PI;
		}
		if ((y2 >= y1) && (x2 < x1)) {
			direction = -direction;
		}
		return(direction);
	}
	public static double direction(Position begin, Position end) {
		return(direction(begin.x, begin.y, end.x, end.y));
	}
	public static Position rotate(Position point, double angle) {
		Position result = new Position(
			point.x * Math.cos(-angle) - point.y * Math.sin(-angle),
			point.x * Math.sin(-angle) + point.y * Math.cos(-angle)
		);
		return(result);
	}
	public static double distance(Position a, Position b) {
		double result = Math.sqrt(
			Math.pow(a.x - b.x, 2) +
			Math.pow(a.y - b.y, 2)
		);
		return(result);
	}
}
