package net.bajobongo.zerro.plansza;

import java.awt.*;
import java.awt.event.*;

public class Plansza extends java.applet.Applet implements Runnable, KeyListener, MouseListener, MouseMotionListener {
	public double frequency;
	Thread animator;
	Thread ticker;
	Dimension offDimension;
	Image offImage;
	public Graphics offGraphics;

	public void init() {
		String str = getParameter("fps");
		int fps = (str != null) ? Integer.parseInt(str) : 10;
		frequency = (fps > 0) ? fps : 10;
		addKeyListener(this);
		addMouseListener(this);
		addMouseMotionListener(this);
	}

	public void keyPressed(KeyEvent e) { }
	public void keyReleased(KeyEvent e) { }
	public void keyTyped(KeyEvent e) { }

	public void mouseEntered(MouseEvent e) { }
	public void mouseExited(MouseEvent e) { }
	public void mousePressed(MouseEvent e) { }
	public void mouseReleased(MouseEvent e) { }
	public void mouseClicked(MouseEvent e) { }

	public void mouseMoved(MouseEvent e) { }
	public void mouseDragged(MouseEvent e) { }

	public void start() {
		animator = new Thread(this);
		animator.start();
	}

	public void run() {
		double delay = 1000 / frequency;
		long tm = System.currentTimeMillis();
		while (Thread.currentThread() == animator) {
			repaint();
			try {
				tm += delay;
				Thread.sleep(Math.max(0, tm - System.currentTimeMillis()));
			} catch (InterruptedException e) {
				break;
			}
		}
	}

	public void stop() {
		animator = null;
		offImage = null;
		offGraphics = null;
	}

	public void update(Graphics g) {
		Dimension d = getSize();
		if (
			(offGraphics == null)
			|| (d.width != offDimension.width)
			|| (d.height != offDimension.height)
		) {
			offDimension = d;
			offImage = createImage(d.width, d.height);
			offGraphics = offImage.getGraphics();
		}
		offGraphics.setColor(getBackground());
		offGraphics.fillRect(0, 0, d.width, d.height);
		offGraphics.setColor(Color.black);
		paintFrame(offGraphics);
		g.drawImage(offImage, 0, 0, null);
	}

	public void paint(Graphics g) {
		if (offImage != null) {
			g.drawImage(offImage, 0, 0, null);
		}
	}

	public void paintFrame(Graphics g) { }
}

